' ======= KONFIGURATION =======

datenbank = "stats3"
user      = "postgres"
passwort  = "postgres"
ordner    = "output"

' =============================


' Zum erstellen der notwendigen Tabellen, folgendes Statements aufrufen:
' CREATE TABLE bev_nat
' (
'   gdenr integer NOT NULL,
'   gdname character varying(100) NOT NULL,
'   geschlecht character(1),
'   jahr integer,
'   "alter" integer,
'   anzahl integer
' ) 
'
' Das ganze noch zwei mal wiederholen mit den Tabellennamen trend_optimistisch und trend_pessimistisch.


' Erstellt und ffnet die Verbindung zur Datenbank mithilfe der Parameter. Das Schliessen nicht vergessen!
Function CreateConnection(DatabaseName, UserID, Password)
    Set cn = CreateObject("ADODB.Connection")
    cn.ConnectionString = "PROVIDER=PostgreSQL;" & _
        "DATA SOURCE=127.0.0.1;" & _
        "LOCATION=" & DatabaseName & ";" & _
        "USER ID=" & UserID & ";" & _
        "PASSWORD=" & Password & ";"
    cn.Open
    Set CreateConnection = cn
End Function

' Fhrt die Einfge-Query aus in die angegebene Tabelle mit den Parametern
Sub ExecuteInsertQuery(tabelle, gemeindeName, gemeindeNummer, geschlecht, year, age, anzahl)
  connection.Execute("INSERT INTO " & tabelle & "(gdenr, gdname, geschlecht, jahr, alter, anzahl) " & _
    "VALUES (" & gemeindeNummer & ", '" & gemeindeName & "', '" & geschlecht & "', " & year & ", " & age & ", " & anzahl & ")")
End Sub

' Ermittelt die Anzahl pro Geschlecht und fgt danach beide in die Datenbank ein
Sub WriteToDatabase(tabelle, gemeindeName, gemeindeNummer, year, age, range)
  ExecuteInsertQuery tabelle, gemeindeName, gemeindeNummer, "m", year, age, CInt(range.Value)
  ExecuteInsertQuery tabelle, gemeindeName, gemeindeNummer, "w", year, age, CInt(range.Offset(0, 1).Value) 
End Sub

' Durchluft die Datenfelder:
' - rangeJahre gibt den Bereich aller Jahre an, fr die Daten vorhanden sind
' - rangeAlter ist die Range, in der die Alter der Personen gespeichert sind
' - startJahre, das Feld mit dem ersten Jahrgang
' - startAlter, das Feld mit dem Alter '0'
' - startDaten, die obere, linke Ecke an der die tatschlichen Daten beginnen
Sub ExtractValues(sheet, tabelle, gemeindeName, gemeindeNummer, rangeJahre, rangeAlter, startJahre, startAlter, startDaten)
  Dim Year, Age, AnzahlJahre
  Dim DataRange
  AnzahlJahre = sheet.Range(rangeJahre).Count
  AnzahlAlter = sheet.Range(rangeAlter).Count
  
  For Row = 0 To AnzahlJahre Step 3
    Year = sheet.Range(startJahre).Offset(0, Row + 1).Value
    
    For Col = 0 To AnzahlAlter - 1
      Set DataRange = sheet.Range(startDaten).Offset(Col, Row)
      If IsNumeric(DataRange.Value) Then
        Age = sheet.Range(startAlter).Offset(Col, 0).Value
        WriteToDatabase tabelle, gemeindeName, gemeindeNummer, year, age, DataRange
      End If
    Next
    
    SetStatusText(statusText & "&nbsp;&nbsp;&nbsp;&nbsp;" & sheet.Name & ": " & CInt(100 * Row  / AnzahlJahre) & "% fertig")
  Next
  
  statusText = statusText & "&nbsp;&nbsp;&nbsp;&nbsp;" & sheet.Name & ": 100% fertig<br/>"
End Sub

Sub SetStatusText(text)
  InternetExplorer.Document.Body.InnerHTML = text
End Sub

function SortArray(arrShort)
  dim i, j, temp
  for i = UBound(arrShort) - 1 To 0 Step -1
    for j= 0 to i
      if arrShort(j)>arrShort(j+1) then
        temp=arrShort(j+1)
        arrShort(j+1)=arrShort(j)
        arrShort(j)=temp
      end if
    next
  next
  SortArray = arrShort
end function


Set InternetExplorer = CreateObject("internetexplorer.application")

InternetExplorer.navigate2 "about:blank"
InternetExplorer.width = 400
InternetExplorer.height = 600
InternetExplorer.toolbar = false
InternetExplorer.menubar = false
InternetExplorer.statusbar = false
InternetExplorer.visible = True

statusText = "<head><title>Import Excel To Postgres</title></head>"
SetStatusText("Initialisiere..")


Set connection = CreateConnection(datenbank, user, passwort)

connection.Execute("TRUNCATE TABLE bev_nat")
connection.Execute("TRUNCATE TABLE trend_optimistisch")
connection.Execute("TRUNCATE TABLE trend_pessimistisch")


basePath = CreateObject("Scripting.FileSystemObject").GetAbsolutePathName(".") & "\" & ordner
Set folder = CreateObject("Scripting.FileSystemObject").GetFolder(basePath)

numberOfExcelFiles = 0
For each excelFile in folder.Files
  If excelFile.Type = "Microsoft Excel Worksheet" Then
    numberOfExcelFiles = numberOfExcelFiles + 1
  End If
Next

Dim excelFiles()
ReDim excelFiles(numberOfExcelFiles - 1)

i = 0
For each excelFile in folder.Files
  If excelFile.Type = "Microsoft Excel Worksheet" Then
    excelFiles(i) = CStr(excelFile.Name)
    i = i + 1
  End If
Next


Set excel = CreateObject("Excel.Application")

For each excelFile in SortArray(excelFiles)

    Set workbook = excel.Workbooks.Open(basePath & "\" & excelFile)
    
    GemeindeName = workbook.Sheets("Bevlkerungsdaten").Range("C5").Value
    GemeindeNummer = workbook.Sheets("Bevlkerungsdaten").Range("B5").Value
    statusText = statusText & "Gemeinde <strong>" & GemeindeName & "</strong><br/>"
    SetStatusText(statusText)
    
    ExtractValues workbook.Sheets("Perspektive_nat_Entwicklung "), "bev_nat", _
      GemeindeName, GemeindeNummer, "G15:BR15", "C18:C128", "G15", "C18", "G18"
      
    ExtractValues workbook.Sheets("Optimistischer Trend"), "trend_optimistisch", _
      GemeindeName, GemeindeNummer, "G15:BR15", "C18:C128", "G15", "C18", "G18"
    
    ExtractValues workbook.Sheets("Pessimistischer Trend"), "trend_pessimistisch", _
      GemeindeName, GemeindeNummer, "G15:BR15", "C18:C128", "G15", "C18", "G18"
    
    statusText = statusText & "<br/>"
    
    excel.ActiveWorkbook.Close False
Next

connection.Close
InternetExplorer.Quit

excel.Quit
